

{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (inaki@blueleaf.cc)

/No description available in the introspection data./
-}

#define ENABLE_OVERLOADING (MIN_VERSION_haskell_gi_overloading(1,0,0) \
       && !defined(__HADDOCK_VERSION__))

module GI.WebKit2.Interfaces.PermissionRequest
    ( 

-- * Exported types
    PermissionRequest(..)                   ,
    noPermissionRequest                     ,
    IsPermissionRequest                     ,
    toPermissionRequest                     ,


 -- * Methods
-- ** allow #method:allow#

#if ENABLE_OVERLOADING
    PermissionRequestAllowMethodInfo        ,
#endif
    permissionRequestAllow                  ,


-- ** deny #method:deny#

#if ENABLE_OVERLOADING
    PermissionRequestDenyMethodInfo         ,
#endif
    permissionRequestDeny                   ,




    ) where

import Data.GI.Base.ShortPrelude
import qualified Data.GI.Base.ShortPrelude as SP
import qualified Data.GI.Base.Overloading as O
import qualified Prelude as P

import qualified Data.GI.Base.Attributes as GI.Attributes
import qualified Data.GI.Base.ManagedPtr as B.ManagedPtr
import qualified Data.GI.Base.GClosure as B.GClosure
import qualified Data.GI.Base.GError as B.GError
import qualified Data.GI.Base.GVariant as B.GVariant
import qualified Data.GI.Base.GValue as B.GValue
import qualified Data.GI.Base.GParamSpec as B.GParamSpec
import qualified Data.GI.Base.CallStack as B.CallStack
import qualified Data.GI.Base.Properties as B.Properties
import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map
import qualified Foreign.Ptr as FP
import qualified GHC.OverloadedLabels as OL

import qualified GI.GObject.Objects.Object as GObject.Object

-- interface PermissionRequest 
-- | Memory-managed wrapper type.
newtype PermissionRequest = PermissionRequest (ManagedPtr PermissionRequest)
-- | A convenience alias for `Nothing` :: `Maybe` `PermissionRequest`.
noPermissionRequest :: Maybe PermissionRequest
noPermissionRequest = Nothing

#if ENABLE_OVERLOADING
type instance O.SignalList PermissionRequest = PermissionRequestSignalList
type PermissionRequestSignalList = ('[ '("notify", GObject.Object.ObjectNotifySignalInfo)] :: [(Symbol, *)])

#endif

foreign import ccall "webkit_permission_request_get_type"
    c_webkit_permission_request_get_type :: IO GType

instance GObject PermissionRequest where
    gobjectType = c_webkit_permission_request_get_type
    

-- | Type class for types which can be safely cast to `PermissionRequest`, for instance with `toPermissionRequest`.
class (GObject o, O.IsDescendantOf PermissionRequest o) => IsPermissionRequest o
instance (GObject o, O.IsDescendantOf PermissionRequest o) => IsPermissionRequest o

instance O.HasParentTypes PermissionRequest
type instance O.ParentTypes PermissionRequest = '[GObject.Object.Object]

-- | Cast to `PermissionRequest`, for types for which this is known to be safe. For general casts, use `Data.GI.Base.ManagedPtr.castTo`.
toPermissionRequest :: (MonadIO m, IsPermissionRequest o) => o -> m PermissionRequest
toPermissionRequest = liftIO . unsafeCastTo PermissionRequest

#if ENABLE_OVERLOADING
instance O.HasAttributeList PermissionRequest
type instance O.AttributeList PermissionRequest = PermissionRequestAttributeList
type PermissionRequestAttributeList = ('[ ] :: [(Symbol, *)])
#endif

#if ENABLE_OVERLOADING
#endif

#if ENABLE_OVERLOADING
type family ResolvePermissionRequestMethod (t :: Symbol) (o :: *) :: * where
    ResolvePermissionRequestMethod "allow" o = PermissionRequestAllowMethodInfo
    ResolvePermissionRequestMethod "bindProperty" o = GObject.Object.ObjectBindPropertyMethodInfo
    ResolvePermissionRequestMethod "bindPropertyFull" o = GObject.Object.ObjectBindPropertyFullMethodInfo
    ResolvePermissionRequestMethod "deny" o = PermissionRequestDenyMethodInfo
    ResolvePermissionRequestMethod "forceFloating" o = GObject.Object.ObjectForceFloatingMethodInfo
    ResolvePermissionRequestMethod "freezeNotify" o = GObject.Object.ObjectFreezeNotifyMethodInfo
    ResolvePermissionRequestMethod "getv" o = GObject.Object.ObjectGetvMethodInfo
    ResolvePermissionRequestMethod "isFloating" o = GObject.Object.ObjectIsFloatingMethodInfo
    ResolvePermissionRequestMethod "notify" o = GObject.Object.ObjectNotifyMethodInfo
    ResolvePermissionRequestMethod "notifyByPspec" o = GObject.Object.ObjectNotifyByPspecMethodInfo
    ResolvePermissionRequestMethod "ref" o = GObject.Object.ObjectRefMethodInfo
    ResolvePermissionRequestMethod "refSink" o = GObject.Object.ObjectRefSinkMethodInfo
    ResolvePermissionRequestMethod "runDispose" o = GObject.Object.ObjectRunDisposeMethodInfo
    ResolvePermissionRequestMethod "stealData" o = GObject.Object.ObjectStealDataMethodInfo
    ResolvePermissionRequestMethod "stealQdata" o = GObject.Object.ObjectStealQdataMethodInfo
    ResolvePermissionRequestMethod "thawNotify" o = GObject.Object.ObjectThawNotifyMethodInfo
    ResolvePermissionRequestMethod "unref" o = GObject.Object.ObjectUnrefMethodInfo
    ResolvePermissionRequestMethod "watchClosure" o = GObject.Object.ObjectWatchClosureMethodInfo
    ResolvePermissionRequestMethod "getData" o = GObject.Object.ObjectGetDataMethodInfo
    ResolvePermissionRequestMethod "getProperty" o = GObject.Object.ObjectGetPropertyMethodInfo
    ResolvePermissionRequestMethod "getQdata" o = GObject.Object.ObjectGetQdataMethodInfo
    ResolvePermissionRequestMethod "setData" o = GObject.Object.ObjectSetDataMethodInfo
    ResolvePermissionRequestMethod "setProperty" o = GObject.Object.ObjectSetPropertyMethodInfo
    ResolvePermissionRequestMethod l o = O.MethodResolutionFailed l o

instance (info ~ ResolvePermissionRequestMethod t PermissionRequest, O.MethodInfo info PermissionRequest p) => OL.IsLabel t (PermissionRequest -> p) where
#if MIN_VERSION_base(4,10,0)
    fromLabel = O.overloadedMethod (O.MethodProxy :: O.MethodProxy info)
#else
    fromLabel _ = O.overloadedMethod (O.MethodProxy :: O.MethodProxy info)
#endif

#endif

-- method PermissionRequest::allow
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "request", argType = TInterface (Name {namespace = "WebKit2", name = "PermissionRequest"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitPermissionRequest", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "webkit_permission_request_allow" webkit_permission_request_allow :: 
    Ptr PermissionRequest ->                -- request : TInterface (Name {namespace = "WebKit2", name = "PermissionRequest"})
    IO ()

{- |
Allow the action which triggered this request.
-}
permissionRequestAllow ::
    (B.CallStack.HasCallStack, MonadIO m, IsPermissionRequest a) =>
    a
    {- ^ /@request@/: a 'GI.WebKit2.Interfaces.PermissionRequest.PermissionRequest' -}
    -> m ()
permissionRequestAllow request = liftIO $ do
    request' <- unsafeManagedPtrCastPtr request
    webkit_permission_request_allow request'
    touchManagedPtr request
    return ()

#if ENABLE_OVERLOADING
data PermissionRequestAllowMethodInfo
instance (signature ~ (m ()), MonadIO m, IsPermissionRequest a) => O.MethodInfo PermissionRequestAllowMethodInfo a signature where
    overloadedMethod _ = permissionRequestAllow

#endif

-- method PermissionRequest::deny
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "request", argType = TInterface (Name {namespace = "WebKit2", name = "PermissionRequest"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitPermissionRequest", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "webkit_permission_request_deny" webkit_permission_request_deny :: 
    Ptr PermissionRequest ->                -- request : TInterface (Name {namespace = "WebKit2", name = "PermissionRequest"})
    IO ()

{- |
Deny the action which triggered this request.
-}
permissionRequestDeny ::
    (B.CallStack.HasCallStack, MonadIO m, IsPermissionRequest a) =>
    a
    {- ^ /@request@/: a 'GI.WebKit2.Interfaces.PermissionRequest.PermissionRequest' -}
    -> m ()
permissionRequestDeny request = liftIO $ do
    request' <- unsafeManagedPtrCastPtr request
    webkit_permission_request_deny request'
    touchManagedPtr request
    return ()

#if ENABLE_OVERLOADING
data PermissionRequestDenyMethodInfo
instance (signature ~ (m ()), MonadIO m, IsPermissionRequest a) => O.MethodInfo PermissionRequestDenyMethodInfo a signature where
    overloadedMethod _ = permissionRequestDeny

#endif


