

{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (inaki@blueleaf.cc)

/No description available in the introspection data./
-}

#define ENABLE_OVERLOADING (MIN_VERSION_haskell_gi_overloading(1,0,0) \
       && !defined(__HADDOCK_VERSION__))

module GI.WebKit2.Objects.DeviceInfoPermissionRequest
    ( 

-- * Exported types
    DeviceInfoPermissionRequest(..)         ,
    IsDeviceInfoPermissionRequest           ,
    toDeviceInfoPermissionRequest           ,
    noDeviceInfoPermissionRequest           ,


    ) where

import Data.GI.Base.ShortPrelude
import qualified Data.GI.Base.ShortPrelude as SP
import qualified Data.GI.Base.Overloading as O
import qualified Prelude as P

import qualified Data.GI.Base.Attributes as GI.Attributes
import qualified Data.GI.Base.ManagedPtr as B.ManagedPtr
import qualified Data.GI.Base.GClosure as B.GClosure
import qualified Data.GI.Base.GError as B.GError
import qualified Data.GI.Base.GVariant as B.GVariant
import qualified Data.GI.Base.GValue as B.GValue
import qualified Data.GI.Base.GParamSpec as B.GParamSpec
import qualified Data.GI.Base.CallStack as B.CallStack
import qualified Data.GI.Base.Properties as B.Properties
import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map
import qualified Foreign.Ptr as FP
import qualified GHC.OverloadedLabels as OL

import qualified GI.GObject.Objects.Object as GObject.Object
import {-# SOURCE #-} qualified GI.WebKit2.Interfaces.PermissionRequest as WebKit2.PermissionRequest

-- | Memory-managed wrapper type.
newtype DeviceInfoPermissionRequest = DeviceInfoPermissionRequest (ManagedPtr DeviceInfoPermissionRequest)
foreign import ccall "webkit_device_info_permission_request_get_type"
    c_webkit_device_info_permission_request_get_type :: IO GType

instance GObject DeviceInfoPermissionRequest where
    gobjectType = c_webkit_device_info_permission_request_get_type
    

-- | Type class for types which can be safely cast to `DeviceInfoPermissionRequest`, for instance with `toDeviceInfoPermissionRequest`.
class (GObject o, O.IsDescendantOf DeviceInfoPermissionRequest o) => IsDeviceInfoPermissionRequest o
instance (GObject o, O.IsDescendantOf DeviceInfoPermissionRequest o) => IsDeviceInfoPermissionRequest o

instance O.HasParentTypes DeviceInfoPermissionRequest
type instance O.ParentTypes DeviceInfoPermissionRequest = '[GObject.Object.Object, WebKit2.PermissionRequest.PermissionRequest]

-- | Cast to `DeviceInfoPermissionRequest`, for types for which this is known to be safe. For general casts, use `Data.GI.Base.ManagedPtr.castTo`.
toDeviceInfoPermissionRequest :: (MonadIO m, IsDeviceInfoPermissionRequest o) => o -> m DeviceInfoPermissionRequest
toDeviceInfoPermissionRequest = liftIO . unsafeCastTo DeviceInfoPermissionRequest

-- | A convenience alias for `Nothing` :: `Maybe` `DeviceInfoPermissionRequest`.
noDeviceInfoPermissionRequest :: Maybe DeviceInfoPermissionRequest
noDeviceInfoPermissionRequest = Nothing

#if ENABLE_OVERLOADING
type family ResolveDeviceInfoPermissionRequestMethod (t :: Symbol) (o :: *) :: * where
    ResolveDeviceInfoPermissionRequestMethod "allow" o = WebKit2.PermissionRequest.PermissionRequestAllowMethodInfo
    ResolveDeviceInfoPermissionRequestMethod "bindProperty" o = GObject.Object.ObjectBindPropertyMethodInfo
    ResolveDeviceInfoPermissionRequestMethod "bindPropertyFull" o = GObject.Object.ObjectBindPropertyFullMethodInfo
    ResolveDeviceInfoPermissionRequestMethod "deny" o = WebKit2.PermissionRequest.PermissionRequestDenyMethodInfo
    ResolveDeviceInfoPermissionRequestMethod "forceFloating" o = GObject.Object.ObjectForceFloatingMethodInfo
    ResolveDeviceInfoPermissionRequestMethod "freezeNotify" o = GObject.Object.ObjectFreezeNotifyMethodInfo
    ResolveDeviceInfoPermissionRequestMethod "getv" o = GObject.Object.ObjectGetvMethodInfo
    ResolveDeviceInfoPermissionRequestMethod "isFloating" o = GObject.Object.ObjectIsFloatingMethodInfo
    ResolveDeviceInfoPermissionRequestMethod "notify" o = GObject.Object.ObjectNotifyMethodInfo
    ResolveDeviceInfoPermissionRequestMethod "notifyByPspec" o = GObject.Object.ObjectNotifyByPspecMethodInfo
    ResolveDeviceInfoPermissionRequestMethod "ref" o = GObject.Object.ObjectRefMethodInfo
    ResolveDeviceInfoPermissionRequestMethod "refSink" o = GObject.Object.ObjectRefSinkMethodInfo
    ResolveDeviceInfoPermissionRequestMethod "runDispose" o = GObject.Object.ObjectRunDisposeMethodInfo
    ResolveDeviceInfoPermissionRequestMethod "stealData" o = GObject.Object.ObjectStealDataMethodInfo
    ResolveDeviceInfoPermissionRequestMethod "stealQdata" o = GObject.Object.ObjectStealQdataMethodInfo
    ResolveDeviceInfoPermissionRequestMethod "thawNotify" o = GObject.Object.ObjectThawNotifyMethodInfo
    ResolveDeviceInfoPermissionRequestMethod "unref" o = GObject.Object.ObjectUnrefMethodInfo
    ResolveDeviceInfoPermissionRequestMethod "watchClosure" o = GObject.Object.ObjectWatchClosureMethodInfo
    ResolveDeviceInfoPermissionRequestMethod "getData" o = GObject.Object.ObjectGetDataMethodInfo
    ResolveDeviceInfoPermissionRequestMethod "getProperty" o = GObject.Object.ObjectGetPropertyMethodInfo
    ResolveDeviceInfoPermissionRequestMethod "getQdata" o = GObject.Object.ObjectGetQdataMethodInfo
    ResolveDeviceInfoPermissionRequestMethod "setData" o = GObject.Object.ObjectSetDataMethodInfo
    ResolveDeviceInfoPermissionRequestMethod "setProperty" o = GObject.Object.ObjectSetPropertyMethodInfo
    ResolveDeviceInfoPermissionRequestMethod l o = O.MethodResolutionFailed l o

instance (info ~ ResolveDeviceInfoPermissionRequestMethod t DeviceInfoPermissionRequest, O.MethodInfo info DeviceInfoPermissionRequest p) => OL.IsLabel t (DeviceInfoPermissionRequest -> p) where
#if MIN_VERSION_base(4,10,0)
    fromLabel = O.overloadedMethod (O.MethodProxy :: O.MethodProxy info)
#else
    fromLabel _ = O.overloadedMethod (O.MethodProxy :: O.MethodProxy info)
#endif

#endif

#if ENABLE_OVERLOADING
instance O.HasAttributeList DeviceInfoPermissionRequest
type instance O.AttributeList DeviceInfoPermissionRequest = DeviceInfoPermissionRequestAttributeList
type DeviceInfoPermissionRequestAttributeList = ('[ ] :: [(Symbol, *)])
#endif

#if ENABLE_OVERLOADING
#endif

#if ENABLE_OVERLOADING
type instance O.SignalList DeviceInfoPermissionRequest = DeviceInfoPermissionRequestSignalList
type DeviceInfoPermissionRequestSignalList = ('[ '("notify", GObject.Object.ObjectNotifySignalInfo)] :: [(Symbol, *)])

#endif


