

{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (inaki@blueleaf.cc)

/No description available in the introspection data./
-}

#define ENABLE_OVERLOADING (MIN_VERSION_haskell_gi_overloading(1,0,0) \
       && !defined(__HADDOCK_VERSION__))

module GI.WebKit2.Structs.JavascriptResult
    ( 

-- * Exported types
    JavascriptResult(..)                    ,
    noJavascriptResult                      ,


 -- * Methods
-- ** getJsValue #method:getJsValue#

#if ENABLE_OVERLOADING
    JavascriptResultGetJsValueMethodInfo    ,
#endif
    javascriptResultGetJsValue              ,


-- ** ref #method:ref#

#if ENABLE_OVERLOADING
    JavascriptResultRefMethodInfo           ,
#endif
    javascriptResultRef                     ,


-- ** unref #method:unref#

#if ENABLE_OVERLOADING
    JavascriptResultUnrefMethodInfo         ,
#endif
    javascriptResultUnref                   ,




    ) where

import Data.GI.Base.ShortPrelude
import qualified Data.GI.Base.ShortPrelude as SP
import qualified Data.GI.Base.Overloading as O
import qualified Prelude as P

import qualified Data.GI.Base.Attributes as GI.Attributes
import qualified Data.GI.Base.ManagedPtr as B.ManagedPtr
import qualified Data.GI.Base.GClosure as B.GClosure
import qualified Data.GI.Base.GError as B.GError
import qualified Data.GI.Base.GVariant as B.GVariant
import qualified Data.GI.Base.GValue as B.GValue
import qualified Data.GI.Base.GParamSpec as B.GParamSpec
import qualified Data.GI.Base.CallStack as B.CallStack
import qualified Data.GI.Base.Properties as B.Properties
import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map
import qualified Foreign.Ptr as FP
import qualified GHC.OverloadedLabels as OL

import qualified GI.JavaScriptCore.Objects.Value as JavaScriptCore.Value

-- | Memory-managed wrapper type.
newtype JavascriptResult = JavascriptResult (ManagedPtr JavascriptResult)
foreign import ccall "webkit_javascript_result_get_type" c_webkit_javascript_result_get_type :: 
    IO GType

instance BoxedObject JavascriptResult where
    boxedType _ = c_webkit_javascript_result_get_type

-- | A convenience alias for `Nothing` :: `Maybe` `JavascriptResult`.
noJavascriptResult :: Maybe JavascriptResult
noJavascriptResult = Nothing


#if ENABLE_OVERLOADING
instance O.HasAttributeList JavascriptResult
type instance O.AttributeList JavascriptResult = JavascriptResultAttributeList
type JavascriptResultAttributeList = ('[ ] :: [(Symbol, *)])
#endif

-- method JavascriptResult::get_js_value
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "js_result", argType = TInterface (Name {namespace = "WebKit2", name = "JavascriptResult"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitJavascriptResult", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "JavaScriptCore", name = "Value"}))
-- throws : False
-- Skip return : False

foreign import ccall "webkit_javascript_result_get_js_value" webkit_javascript_result_get_js_value :: 
    Ptr JavascriptResult ->                 -- js_result : TInterface (Name {namespace = "WebKit2", name = "JavascriptResult"})
    IO (Ptr JavaScriptCore.Value.Value)

{- |
Get the 'GI.JavaScriptCore.Objects.Value.Value' of /@jsResult@/.

/Since: 2.22/
-}
javascriptResultGetJsValue ::
    (B.CallStack.HasCallStack, MonadIO m) =>
    JavascriptResult
    {- ^ /@jsResult@/: a 'GI.WebKit2.Structs.JavascriptResult.JavascriptResult' -}
    -> m JavaScriptCore.Value.Value
    {- ^ __Returns:__ the 'GI.JavaScriptCore.Objects.Value.Value' of the 'GI.WebKit2.Structs.JavascriptResult.JavascriptResult' -}
javascriptResultGetJsValue jsResult = liftIO $ do
    jsResult' <- unsafeManagedPtrGetPtr jsResult
    result <- webkit_javascript_result_get_js_value jsResult'
    checkUnexpectedReturnNULL "javascriptResultGetJsValue" result
    result' <- (newObject JavaScriptCore.Value.Value) result
    touchManagedPtr jsResult
    return result'

#if ENABLE_OVERLOADING
data JavascriptResultGetJsValueMethodInfo
instance (signature ~ (m JavaScriptCore.Value.Value), MonadIO m) => O.MethodInfo JavascriptResultGetJsValueMethodInfo JavascriptResult signature where
    overloadedMethod _ = javascriptResultGetJsValue

#endif

-- method JavascriptResult::ref
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "js_result", argType = TInterface (Name {namespace = "WebKit2", name = "JavascriptResult"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitJavascriptResult", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "WebKit2", name = "JavascriptResult"}))
-- throws : False
-- Skip return : False

foreign import ccall "webkit_javascript_result_ref" webkit_javascript_result_ref :: 
    Ptr JavascriptResult ->                 -- js_result : TInterface (Name {namespace = "WebKit2", name = "JavascriptResult"})
    IO (Ptr JavascriptResult)

{- |
Atomically increments the reference count of /@jsResult@/ by one. This
function is MT-safe and may be called from any thread.
-}
javascriptResultRef ::
    (B.CallStack.HasCallStack, MonadIO m) =>
    JavascriptResult
    {- ^ /@jsResult@/: a 'GI.WebKit2.Structs.JavascriptResult.JavascriptResult' -}
    -> m JavascriptResult
    {- ^ __Returns:__ The passed in 'GI.WebKit2.Structs.JavascriptResult.JavascriptResult' -}
javascriptResultRef jsResult = liftIO $ do
    jsResult' <- unsafeManagedPtrGetPtr jsResult
    result <- webkit_javascript_result_ref jsResult'
    checkUnexpectedReturnNULL "javascriptResultRef" result
    result' <- (wrapBoxed JavascriptResult) result
    touchManagedPtr jsResult
    return result'

#if ENABLE_OVERLOADING
data JavascriptResultRefMethodInfo
instance (signature ~ (m JavascriptResult), MonadIO m) => O.MethodInfo JavascriptResultRefMethodInfo JavascriptResult signature where
    overloadedMethod _ = javascriptResultRef

#endif

-- method JavascriptResult::unref
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "js_result", argType = TInterface (Name {namespace = "WebKit2", name = "JavascriptResult"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitJavascriptResult", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "webkit_javascript_result_unref" webkit_javascript_result_unref :: 
    Ptr JavascriptResult ->                 -- js_result : TInterface (Name {namespace = "WebKit2", name = "JavascriptResult"})
    IO ()

{- |
Atomically decrements the reference count of /@jsResult@/ by one. If the
reference count drops to 0, all memory allocated by the 'GI.WebKit2.Structs.JavascriptResult.JavascriptResult' is
released. This function is MT-safe and may be called from any
thread.
-}
javascriptResultUnref ::
    (B.CallStack.HasCallStack, MonadIO m) =>
    JavascriptResult
    {- ^ /@jsResult@/: a 'GI.WebKit2.Structs.JavascriptResult.JavascriptResult' -}
    -> m ()
javascriptResultUnref jsResult = liftIO $ do
    jsResult' <- unsafeManagedPtrGetPtr jsResult
    webkit_javascript_result_unref jsResult'
    touchManagedPtr jsResult
    return ()

#if ENABLE_OVERLOADING
data JavascriptResultUnrefMethodInfo
instance (signature ~ (m ()), MonadIO m) => O.MethodInfo JavascriptResultUnrefMethodInfo JavascriptResult signature where
    overloadedMethod _ = javascriptResultUnref

#endif

#if ENABLE_OVERLOADING
type family ResolveJavascriptResultMethod (t :: Symbol) (o :: *) :: * where
    ResolveJavascriptResultMethod "ref" o = JavascriptResultRefMethodInfo
    ResolveJavascriptResultMethod "unref" o = JavascriptResultUnrefMethodInfo
    ResolveJavascriptResultMethod "getJsValue" o = JavascriptResultGetJsValueMethodInfo
    ResolveJavascriptResultMethod l o = O.MethodResolutionFailed l o

instance (info ~ ResolveJavascriptResultMethod t JavascriptResult, O.MethodInfo info JavascriptResult p) => OL.IsLabel t (JavascriptResult -> p) where
#if MIN_VERSION_base(4,10,0)
    fromLabel = O.overloadedMethod (O.MethodProxy :: O.MethodProxy info)
#else
    fromLabel _ = O.overloadedMethod (O.MethodProxy :: O.MethodProxy info)
#endif

#endif


