

{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (inaki@blueleaf.cc)

/No description available in the introspection data./
-}

#define ENABLE_OVERLOADING (MIN_VERSION_haskell_gi_overloading(1,0,0) \
       && !defined(__HADDOCK_VERSION__))

module GI.WebKit2.Structs.UserContentFilter
    ( 

-- * Exported types
    UserContentFilter(..)                   ,
    noUserContentFilter                     ,


 -- * Methods
-- ** getIdentifier #method:getIdentifier#

#if ENABLE_OVERLOADING
    UserContentFilterGetIdentifierMethodInfo,
#endif
    userContentFilterGetIdentifier          ,


-- ** ref #method:ref#

#if ENABLE_OVERLOADING
    UserContentFilterRefMethodInfo          ,
#endif
    userContentFilterRef                    ,


-- ** unref #method:unref#

#if ENABLE_OVERLOADING
    UserContentFilterUnrefMethodInfo        ,
#endif
    userContentFilterUnref                  ,




    ) where

import Data.GI.Base.ShortPrelude
import qualified Data.GI.Base.ShortPrelude as SP
import qualified Data.GI.Base.Overloading as O
import qualified Prelude as P

import qualified Data.GI.Base.Attributes as GI.Attributes
import qualified Data.GI.Base.ManagedPtr as B.ManagedPtr
import qualified Data.GI.Base.GClosure as B.GClosure
import qualified Data.GI.Base.GError as B.GError
import qualified Data.GI.Base.GVariant as B.GVariant
import qualified Data.GI.Base.GValue as B.GValue
import qualified Data.GI.Base.GParamSpec as B.GParamSpec
import qualified Data.GI.Base.CallStack as B.CallStack
import qualified Data.GI.Base.Properties as B.Properties
import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map
import qualified Foreign.Ptr as FP
import qualified GHC.OverloadedLabels as OL


-- | Memory-managed wrapper type.
newtype UserContentFilter = UserContentFilter (ManagedPtr UserContentFilter)
foreign import ccall "webkit_user_content_filter_get_type" c_webkit_user_content_filter_get_type :: 
    IO GType

instance BoxedObject UserContentFilter where
    boxedType _ = c_webkit_user_content_filter_get_type

-- | A convenience alias for `Nothing` :: `Maybe` `UserContentFilter`.
noUserContentFilter :: Maybe UserContentFilter
noUserContentFilter = Nothing


#if ENABLE_OVERLOADING
instance O.HasAttributeList UserContentFilter
type instance O.AttributeList UserContentFilter = UserContentFilterAttributeList
type UserContentFilterAttributeList = ('[ ] :: [(Symbol, *)])
#endif

-- method UserContentFilter::get_identifier
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "user_content_filter", argType = TInterface (Name {namespace = "WebKit2", name = "UserContentFilter"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitUserContentFilter", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TUTF8)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_user_content_filter_get_identifier" webkit_user_content_filter_get_identifier :: 
    Ptr UserContentFilter ->                -- user_content_filter : TInterface (Name {namespace = "WebKit2", name = "UserContentFilter"})
    IO CString

{- |
Obtain the identifier previously used to save the /@userContentFilter@/ in the
'GI.WebKit2.Objects.UserContentFilterStore.UserContentFilterStore'.

/Since: 2.24/
-}
userContentFilterGetIdentifier ::
    (B.CallStack.HasCallStack, MonadIO m) =>
    UserContentFilter
    {- ^ /@userContentFilter@/: A 'GI.WebKit2.Structs.UserContentFilter.UserContentFilter' -}
    -> m T.Text
    {- ^ __Returns:__ the identifier for the filter -}
userContentFilterGetIdentifier userContentFilter = liftIO $ do
    userContentFilter' <- unsafeManagedPtrGetPtr userContentFilter
    result <- webkit_user_content_filter_get_identifier userContentFilter'
    checkUnexpectedReturnNULL "userContentFilterGetIdentifier" result
    result' <- cstringToText result
    touchManagedPtr userContentFilter
    return result'

#if ENABLE_OVERLOADING
data UserContentFilterGetIdentifierMethodInfo
instance (signature ~ (m T.Text), MonadIO m) => O.MethodInfo UserContentFilterGetIdentifierMethodInfo UserContentFilter signature where
    overloadedMethod _ = userContentFilterGetIdentifier

#endif

-- method UserContentFilter::ref
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "user_content_filter", argType = TInterface (Name {namespace = "WebKit2", name = "UserContentFilter"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitUserContentFilter", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "WebKit2", name = "UserContentFilter"}))
-- throws : False
-- Skip return : False

foreign import ccall "webkit_user_content_filter_ref" webkit_user_content_filter_ref :: 
    Ptr UserContentFilter ->                -- user_content_filter : TInterface (Name {namespace = "WebKit2", name = "UserContentFilter"})
    IO (Ptr UserContentFilter)

{- |
Atomically increments the reference count of /@userContentFilter@/ by one.
This function is MT-safe and may be called from any thread.

/Since: 2.24/
-}
userContentFilterRef ::
    (B.CallStack.HasCallStack, MonadIO m) =>
    UserContentFilter
    {- ^ /@userContentFilter@/: A 'GI.WebKit2.Structs.UserContentFilter.UserContentFilter' -}
    -> m UserContentFilter
userContentFilterRef userContentFilter = liftIO $ do
    userContentFilter' <- unsafeManagedPtrGetPtr userContentFilter
    result <- webkit_user_content_filter_ref userContentFilter'
    checkUnexpectedReturnNULL "userContentFilterRef" result
    result' <- (wrapBoxed UserContentFilter) result
    touchManagedPtr userContentFilter
    return result'

#if ENABLE_OVERLOADING
data UserContentFilterRefMethodInfo
instance (signature ~ (m UserContentFilter), MonadIO m) => O.MethodInfo UserContentFilterRefMethodInfo UserContentFilter signature where
    overloadedMethod _ = userContentFilterRef

#endif

-- method UserContentFilter::unref
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "user_content_filter", argType = TInterface (Name {namespace = "WebKit2", name = "UserContentFilter"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitUserContentFilter", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "webkit_user_content_filter_unref" webkit_user_content_filter_unref :: 
    Ptr UserContentFilter ->                -- user_content_filter : TInterface (Name {namespace = "WebKit2", name = "UserContentFilter"})
    IO ()

{- |
Atomically decrements the reference count of /@userContentFilter@/ by one.
If the reference count drops to 0, all the memory allocated by the
'GI.WebKit2.Structs.UserContentFilter.UserContentFilter' is released. This function is MT-safe and may
be called from any thread.

/Since: 2.24/
-}
userContentFilterUnref ::
    (B.CallStack.HasCallStack, MonadIO m) =>
    UserContentFilter
    {- ^ /@userContentFilter@/: A 'GI.WebKit2.Structs.UserContentFilter.UserContentFilter' -}
    -> m ()
userContentFilterUnref userContentFilter = liftIO $ do
    userContentFilter' <- unsafeManagedPtrGetPtr userContentFilter
    webkit_user_content_filter_unref userContentFilter'
    touchManagedPtr userContentFilter
    return ()

#if ENABLE_OVERLOADING
data UserContentFilterUnrefMethodInfo
instance (signature ~ (m ()), MonadIO m) => O.MethodInfo UserContentFilterUnrefMethodInfo UserContentFilter signature where
    overloadedMethod _ = userContentFilterUnref

#endif

#if ENABLE_OVERLOADING
type family ResolveUserContentFilterMethod (t :: Symbol) (o :: *) :: * where
    ResolveUserContentFilterMethod "ref" o = UserContentFilterRefMethodInfo
    ResolveUserContentFilterMethod "unref" o = UserContentFilterUnrefMethodInfo
    ResolveUserContentFilterMethod "getIdentifier" o = UserContentFilterGetIdentifierMethodInfo
    ResolveUserContentFilterMethod l o = O.MethodResolutionFailed l o

instance (info ~ ResolveUserContentFilterMethod t UserContentFilter, O.MethodInfo info UserContentFilter p) => OL.IsLabel t (UserContentFilter -> p) where
#if MIN_VERSION_base(4,10,0)
    fromLabel = O.overloadedMethod (O.MethodProxy :: O.MethodProxy info)
#else
    fromLabel _ = O.overloadedMethod (O.MethodProxy :: O.MethodProxy info)
#endif

#endif


